<?php
/*	Modul: alkisfsnw.php

	ALKIS-Buchauskunft, Kommunales Rechenzentrum Minden-Ravensberg/Lippe (Lemgo).
	Flurstücksnachweis fuer ein Flurstückskennzeichen aus ALKIS PostNAS

	Version:
	2016-02-24 Version fuer norGIS-ALKIS-Import
	2016-03-14 Korrekturen
	2016-12-01 HTML5, Gemeinsam genutzte Datenbanken ermöglichen
	2016-12-05 Nutzungsart-Kategorie ist nun in Text enthalten, nicht mehr aus der Definition ausschneiden
	2017-06-08 optional "berechtigte Buchungen" anzeigen, Function "eigentuemer" ohne Parameter $con,
				Validierung Eingabeparameter, Feinkorrekturen
	2017-10-11 Sauber filtern auf 'endet IS NULL', Ausgabe der Bodenschätzung
	2017-10-11 Nachbesserung Formatierung der Schätzungs-Zeilen
	2017-10-17 Zeitpunkt der Entstehung in deutschen Datumsformat
	2017-11-03 Wertelisten für Arrays in Bodenschätzung ausgeben.
	2017-12-08 Planung (Kommentare) der Erweiterung für Berechtigte Grundbücher
	2017-12-20 Links auf Lagebezeichnung verbessert.
	2018-04-11 Variable "gmlid" an Function "ALKISexport" übergeben. Ist beim Schreiben des Headers noch unbekannt, wenn mit "&fskennz=" aufgerufen.
	2018-04-23 Umfangreiche Überarbeitung der "Buchungsstellen"
	2018-05-03 Anpassung für Grundstücksnachweis
	2018-11-09 Umstellung Full-Schema
	2018-11-19 Entschlüsseln "zeigtaufexternes_art" mit function fortfuehrungen().
	2018-12-18 function fskenn_dbformat

++ToDo:
	- Buchung auf "fiktives Blatt" ist nur mit debug zu sehen: die <tr> in .css grau hinterlegen
	- Umschalter (gleiches Modul) anders darstellen als Links zu anderen Nachweisen
	- Parameter zum Umschalten mit/ohne Bodenschätzung?
	- Bessere Differenzierung bei den Nutzungsarten (Tabelle dafür aufbauen) 
*/
session_start();
$eig="n"; $showkey="n"; $nodebug=""; // Var. initalisieren
$cntget = extract($_GET); // alle Parameter in Variable umwandeln

// strikte Validierung aller Parameter
if (isset($gmlid)) {
	if (!preg_match('#^[0-9A-Za-z]{16}$#', $gmlid)) {die("Eingabefehler gmlid");}
	$fskennz='';
} else { // Alternativ
	$gmlid='';
	if (isset($fskennz)) { // llgggg-fff-11111/222 oder z.B.'052647002001910013__' oder '05264700200012______'
		if (!preg_match('#^[0-9\-_/]{8,20}$#', $fskennz)) {die ("Eingabefehler fskennz");}
	} else {
		$fskennz='';
	}
}
if (!isset($gkz) or !preg_match('#^[0-9]{3}$#', $gkz)) {die("Eingabefehler gkz");}
if (!preg_match('#^[j|n]{0,1}$#', $eig)) {die("Eingabefehler eig");}
if (!preg_match('#^[j|n]{0,1}$#', $showkey)) {die ("Eingabefehler showkey");}
if ($showkey == "j") {$showkey=true;} else {$showkey=false;} // "j"/"n" als boolean umwandeln, ist praktischer abzufragen, wird oft gebraucht
if (!preg_match('#^j{0,1}$#', $nodebug)) {die("Eingabefehler nodebug");}

require_once("alkis_conf_location.php");
if ($auth == "mapbender") {require_once($mapbender);}
include("alkisfkt.php");
?>
<!doctype html>
<html lang="de">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<title>ALKIS Flurst&uuml;cksnachweis</title>
	<link rel="stylesheet" type="text/css" href="alkisauszug.css">
	<link rel="shortcut icon" type="image/x-icon" href="ico/Flurstueck.ico">
	<script>
		function ALKISexport(gmlid) {
			window.open('alkisexport.php?gkz=<?php echo $gkz;?>&tabtyp=flurstueck&gmlid=' + gmlid);
		}
	</script>
</head>
<body>
<?php
// Mit URL-Parameter "&nodebug=j" kann man die Entwicklungsumgebung (in Conf definiert) ausschalten. Blendet z.B. "fiktives Blatt" aus.
// Manuell an die URL anfügen, wirkt nur temporär und wird nicht in Links weiter gereicht.
if ($nodebug == "j") {$debug=0;} 

$con = pg_connect($dbconn." options='--application_name=ALKIS-Auskunft_alkisfsnw.php'");
if (!$con) echo "\n<p class='err'>Fehler beim Verbinden der DB</p>";

// Ein Flurstücks-Kennzeichen wurde alternativ zur gml_id übermittelt
if ($fskennz != '') {
/*
	$arr=explode("-", $fskennz, 4); // zerlegen
	$zgemkg=trim($arr[0]);
	if (strlen($zgemkg) == 20 and !isset($arr[1])) {
		$fskzdb=$zgemkg; // Datenbank-Feldformat
	} else { // Format "llgggg-fff-nnnn/zz.nn" oder "gggg-ff-nnn/zz"
		// Das Kennzeichen auseinander nehmen. 
		if (strlen($zgemkg) == 6) {
			$land=substr($zgemkg, 0, 2);
			$zgemkg=substr($zgemkg, 2, 4);
		} else { // kein schöner Land ..
			$land=$defland; // Default-Land aus config
		}
		$zflur=str_pad($arr[1], 3 , "0", STR_PAD_LEFT); // Flur-Nr
		$zfsnr=trim($arr[2]); // Flurstücke-Nr
		$zn=explode("/", $zfsnr, 2); // Bruch?
		$zzaehler=str_pad(trim($zn[0]), 5 , "0", STR_PAD_LEFT);
		if (isset($zn[1])) {
			$znenner=trim($zn[1]);
		} else {
			$znenner="";
		}
		if (trim($znenner, " 0.") == "") { // kein Bruch oder nur Nullen
			$znenner="____"; // in DB-Spalte mit Tiefstrich aufgefüllt
		} else {
			$zn=explode(".", $znenner, 2); // .00 wegwerfen
			$znenner=str_pad($zn[0], 4 , "0", STR_PAD_LEFT);
		}
		// nun die Teile stellengerecht wieder zusammen setzen		
		$fskzdb=$land.$zgemkg.$zflur.$zzaehler.$znenner.'__'; // FS-Kennz. Format Datenbank
	}
	$v = array($fskzdb);
*/
	// Spalte "flurstueckskennzeichen" ist in DB indiziert
	// Format z.B.'052647002001910013__' oder '05264700200012______'
	$sql ="SELECT gml_id FROM ax_flurstueck WHERE flurstueckskennzeichen= $1 AND endet IS NULL ;";

	$v=array(fskenn_dbformat($fskennz));

	$res = pg_prepare("", $sql);
	$res = pg_execute("", $v);
	if ($row = pg_fetch_assoc($res)) {
		$gmlid=$row["gml_id"];
	} else {
		echo "\n<p class='err'>Fehler! Kein Treffer f&uuml;r Flurst&uuml;ckskennzeichen='".$fskennz."' (".$fskzdb.")</p>";
		echo "<p>Kennzeichen veraltet? <a href='./alkisfshist.php?gkz=".$gkz."&fskennz=".$fskennz."'>Suche in der Flurst&uuml;cks-Historie</a></p>";
		echo "\n</body>\n</html>";
		return;
	}
	pg_free_result($res);
}

// F L U R S T U E C K  m. Gebiet
$sql ="SELECT f.zeigtaufexternes_art, f.zeigtaufexternes_name, f.flurnummer, f.zaehler, f.nenner, f.gemeindezugehoerigkeit_regierungsbezirk, f.gemeindezugehoerigkeit_kreis, f.gemeindezugehoerigkeit_gemeinde, f.amtlicheflaeche, st_area(f.wkb_geometry) AS fsgeomflae, 
to_char(cast(f.zeitpunktderentstehung AS date),'DD.MM.YYYY') AS zeitpunktderentstehung, f.istgebucht, g.gemarkungsnummer, g.bezeichnung, r.bezeichnung AS rbez, k.bezeichnung AS kbez, m.bezeichnung AS mbez 
FROM ax_flurstueck f 
LEFT JOIN ax_gemarkung g ON f.gemeindezugehoerigkeit_land=g.land AND f.gemarkungsnummer=g.gemarkungsnummer 
LEFT JOIN ax_regierungsbezirk r ON f.gemeindezugehoerigkeit_regierungsbezirk=r.regierungsbezirk 
LEFT JOIN ax_kreisregion k ON f.gemeindezugehoerigkeit_regierungsbezirk=k.regierungsbezirk AND f.gemeindezugehoerigkeit_kreis=k.kreis 
LEFT JOIN ax_gemeinde m ON m.regierungsbezirk=f.gemeindezugehoerigkeit_regierungsbezirk AND m.kreis=f.gemeindezugehoerigkeit_kreis AND m.gemeinde=f.gemeindezugehoerigkeit_gemeinde
WHERE f.gml_id= $1 AND f.endet IS NULL AND g.endet IS NULL AND m.endet IS NULL AND k.endet IS NULL AND r.endet IS NULL;";

$v = array($gmlid); // mit gml_id suchen
$res = pg_prepare("", $sql);
$res = pg_execute("", $v);
if (!$res) {
	echo "\n<p class='err'>Fehler bei Flurstuecksdaten</p>";
	if ($debug > 2) {echo "\n<p class='dbg'>SQL=<br>".htmlentities($sql, ENT_QUOTES, "UTF-8")."<br>$1 = gml_id = '".$gmlid."'</p>";}
}
if ($row = pg_fetch_assoc($res)) {
	$gemkname=htmlentities($row["bezeichnung"], ENT_QUOTES, "UTF-8");
	$gmkgnr=$row["gemarkungsnummer"];
	$bezirk=$row["gemeindezugehoerigkeit_regierungsbezirk"];
	$rbez=htmlentities($row["rbez"], ENT_QUOTES, "UTF-8");
	$kreis=$row["gemeindezugehoerigkeit_kreis"];
	$kbez=htmlentities($row["kbez"], ENT_QUOTES, "UTF-8");
	$gemeinde=$row["gemeindezugehoerigkeit_gemeinde"];
	$mbez=htmlentities($row["mbez"], ENT_QUOTES, "UTF-8");
	$flurnummer=$row["flurnummer"];
	$zaehler=$row["zaehler"];
	$nenner=$row["nenner"];
	$flstnummer=$zaehler;
	if ($nenner > 0) {$flstnummer.="/".$nenner;} // BruchNr
	$fsbuchflae=$row["amtlicheflaeche"]; // amtliche Fl. aus DB-Feld
	$fsgeomflae=$row["fsgeomflae"]; // aus Geometrie ermittelte Fläche
	$the_Xfactor = $fsbuchflae / $fsgeomflae; // Multiplikator zur Umrechnung geometrische Abschnittsflächen in Buchfläche
	$fsbuchflaed=number_format($fsbuchflae,0,",",".") . " m&#178;"; // Display-Format dazu
	$fsgeomflaed=number_format($fsgeomflae,0,",",".") . " m&#178;";
	$gml_buchungsstelle=$row["istgebucht"]; // wird erst im GB-Teil benötigt
	$entsteh=$row["zeitpunktderentstehung"];
	$zeart=$row["zeigtaufexternes_art"];
	$zename=$row["zeigtaufexternes_name"];
} else {
	echo "\n<p class='err'>Fehler! Kein Treffer f&uuml;r Flurst&uuml;ck mit gml_id=".$gmlid."</p>";
	if ($debug > 2) {echo "\n<p class='dbg'>SQL=<br>".htmlentities($sql, ENT_QUOTES, "UTF-8")."<br>$1 = gml_id = '".$gmlid."'</p>";}
	echo "\n</body>\n</html>";
	return;
}
pg_free_result($res);

if ($eig=="j") { // Balken
	echo "<p class='fsei'>ALKIS Flurst&uuml;ck ".$gmkgnr."-".$flurnummer."-".$flstnummer."&nbsp;</p>"
	."\n\n<h2>Flurst&uuml;ck mit Eigent&uuml;mer</h2>";
} else {
	echo "<p class='fskennz'>ALKIS Flurst&uuml;ck ".$gmkgnr."-".$flurnummer."-".$flstnummer."&nbsp;</p>"
	."\n\n<h2>Flurst&uuml;ck</h2>";
}

// Prüfung der Gebiets-Berechtigung bei gemeinsam genutzten Datenbanken (Kreis und Gemeinde)
// Für das gkz (z.B. aus dem Mapfile-Namen) wird in der Konfiguration ein Filter gesetzt.
if ( ($filtkreis != '' and $filtkreis != $kreis) or ($filtgem != '' and $filtgem != $gemeinde) ) {
	// Einer der gesetzten Filter passt nicht
	if ($debug > 2) { //++ Schönes Bild? Stop-Zeichen?
		echo "\n<p class='err'>Filter Kreis='".$filtkreis."', Gemeinde='".$filtgem."'</p>"
		."\n<p class='err'>Flstk. Kreis='".$fskrs."', Gemeinde='".$fsgem."'</p>";
	}
	echo "\n<br><p class='stop1'>Zugriff nicht erlaubt</p>"
	."\n<br><p class='stop2'>Dies Flurst&uuml;ck liegt ausserhalb der zust&auml;ndigen Stadt oder Gemeinde.</p>\n</body>\n</html>";
	exit;
}

echo "\n<table class='outer'>"
	."\n\t<tr>\n\t\t<td class='ll'><img src='ico/Flurstueck.png' width='16' height='16' alt=''> Kennzeichen:</td>" // Links
	."\n\t\t<td>" // Mitte
	."\n\t\t\t<table class='kennzfs' title='Flurst&uuml;ckskennzeichen'>\n\t\t\t\t<tr>" // darin Tabelle Kennzeichen
		."\n\t\t\t\t\t<td class='head'>Gemarkung</td>\n\t\t\t\t\t<td class='head'>Flur</td>\n\t\t\t\t\t<td class='head'>Flurst-Nr.</td>\n\t\t\t\t</tr>"
		."\n\t\t\t\t<tr>\n\t\t\t\t\t<td title='Gemarkung'>";
			if ($showkey) {echo "<span class='key'>".$gmkgnr."</span><br>";}
			echo $gemkname."&nbsp;</td>"
		."\n\t\t\t\t\t<td title='Flurnummer'>".$flurnummer."</td>"
		."\n\t\t\t\t\t<td title='Flurst&uuml;cksnummer (Z&auml;hler / Nenner)'><span class='wichtig'>".$flstnummer."</span></td>\n\t\t\t\t</tr>"
	."\n\t\t\t</table>"
	."\n\t\t</td>\n\t\t<td>"; // Rechts
	fortfuehrungen($entsteh, $zeart, $zename);
echo "\n\t\t</td>\n\t</tr>\n</table>";

echo "\n<hr>\n<table class='fs'>"; // FS-Teil 6 Spalten
echo "\n<tr>\n\t\t<td></td>\n\t\t<td></td>\n\t\t<td></td>\n\t\t<td></td>\n\t\t<td></td>" // 1-5 in erster Zeile kein "colspan" verwenden
	."\n\t\t<td>\n\t\t<p class='nwlink noprint'>weitere Auskunft:</p></td>" // 6
."\n</tr>";

echo "\n<tr>" // Zeile: G e b i e t s z u g e h o e r i g k e i t  Gemeinde / Kreis / Regierungsbezirk
	."\n\t<td class='ll'><img title='Im Gebiet von' src='ico/Gemeinde.png' width='16' height='16' alt=''> Gebiet:</td>" // 1
	."\n\t<td>Gemeinde<br>Kreis<br>Regierungsbezirk</td>" // 2
	."\n\t<td class='lr' colspan='3'>"; // 3-5
		if ($showkey) {echo "<span class='key'>(".$gemeinde.")</span> ";}
		echo $mbez."<br>";
		if ($showkey) {echo "<span class='key'>(".$kreis.")</span> ";}
		echo $kbez."<br>";
		if ($showkey) {echo "<span class='key'>(".$bezirk.")</span> ";}
		echo $rbez
	."</td>"
	."\n\t<td class='nwlink'>" // 5
		."\n\t\t<p class='nwlink noprint'>"
		."\n\t\t\t<a href='alkisfshist.php?gkz=".$gkz."&amp;gmlid=".$gmlid;
		if ($showkey) {echo "&amp;showkey=j";}
		echo "' title='Vorg&auml;nger-Flurst&uuml;cke'>Historie "
		."<img src='ico/Flurstueck_Historisch.png' width='16' height='16' alt=''>"
		."</a>"
		."\n\t\t</p>"
	."\n\t</td>" // 6
."\n</tr>";

// ** L a g e b e z e i c h n u n g **

// Lagebezeichnung  M I T  Hausnummer
// ax_flurstueck  >weistAuf>  AX_LagebezeichnungMitHausnummer
$sql="SELECT DISTINCT l.gml_id, l.gemeinde, l.lage, l.hausnummer, s.bezeichnung, s.gml_id AS kgml
FROM ax_flurstueck f JOIN ax_lagebezeichnungmithausnummer l ON l.gml_id=ANY(f.weistauf)  
JOIN ax_lagebezeichnungkatalogeintrag s ON l.land=s.land AND l.regierungsbezirk=s.regierungsbezirk AND l.kreis=s.kreis AND l.gemeinde=s.gemeinde AND l.lage=s.lage 
WHERE f.gml_id= $1 AND f.endet IS NULL AND l.endet IS NULL AND s.endet IS NULL    
ORDER BY l.gemeinde, l.lage, l.hausnummer;";

$v = array($gmlid);
$res = pg_prepare("", $sql);
$res = pg_execute("", $v);

if (!$res) {
	echo "\n<p class='err'>Fehler bei Lagebezeichnung mit Hausnummer</p>";
	if ($debug > 1) {
		echo "\n<p class='dbg'>Fehler:".pg_last_error()."</p>";
		if ($debug > 2) {echo "\n<p class='dbg'>SQL=<br>".htmlentities($sql, ENT_QUOTES, "UTF-8")."<br>$1 = gml_id = '".$gmlid."'</p>";}
	}
} else {
	$j=0;
	$kgmlalt="";
	while($row = pg_fetch_assoc($res)) {
		$sname=htmlentities($row["bezeichnung"], ENT_QUOTES, "UTF-8"); // Str.-Name
		if (substr($sname, strlen($sname) -3, 3) == 'weg') { // Versuch fuer korrekten Satzbau
			$slink=" am ".$sname;
		} else {
			$slink=" an der ".$sname;
		}
		$hsnr=$row["hausnummer"];
		echo "\n<tr>";
			if ($j == 0) { // 1
				echo "\n\t<td class='ll'><img src='ico/Lage_mit_Haus.png' width='16' height='16' alt=''> Adresse:</td>";
			} else {
				echo "\n\t<td>&nbsp;</td>";
			}
			echo "\n\t<td>&nbsp;</td>" // 2
			."\n\t<td class='lr' colspan='3'>"; // 3-5
				if ($showkey) {echo "<span class='key' title='Straßenschl&uuml;ssel'>(".$row["lage"].")</span>&nbsp;";}
				echo $sname."&nbsp;".$hsnr."</td>";
			echo "\n\t<td>\n\t\t<p class='nwlink noprint'>"; // 6

			// +++ davor auch Link "Straße"
			$kgml=$row["kgml"]; // Wiederholung vermeiden
			if ($kgml != $kgmlalt) { // NEUE Strasse vor Lage
				$kgmlalt=$kgml; // Katalog GML-ID
				echo "\n\t\t\t<a title='Flurst&uuml;cke mit oder ohne Hausnummer".$slink."' "
				."href='alkisstrasse.php?gkz=".$gkz."&amp;gmlid=".$kgml."'>Stra&szlig;e "
				."<img src='ico/Strassen.png' width='16' height='16' alt='STRA'></a> ";
			}

			echo "\n\t\t\t<a title='Flurst&uuml;cke und Geb&auml;ude mit Hausnummer ".$hsnr."' href='alkislage.php?gkz=".$gkz."&amp;ltyp=m&amp;gmlid=".$row["gml_id"];
				if ($showkey) {echo "&amp;showkey=j";}
				echo "'>Lage <img src='ico/Lage_mit_Haus.png' width='16' height='16' alt=''></a>"
			."\n\t\t</p>\n\t</td>"  // 6
		."\n</tr>";
		$j++;
	}
	$cnt_adressen=$j;
	pg_free_result($res);
}

// Lagebezeichnung  O H N E  Hausnummer  (Gewanne oder nur Strasse)
// ax_flurstueck  >zeigtAuf>  AX_LagebezeichnungOhneHausnummer
$sql ="SELECT l.gml_id, l.unverschluesselt, l.gemeinde, l.lage, s.bezeichnung 
FROM ax_flurstueck f JOIN ax_lagebezeichnungohnehausnummer l ON l.gml_id=ANY(f.zeigtauf) 
LEFT JOIN ax_lagebezeichnungkatalogeintrag s ON l.land=s.land AND l.regierungsbezirk=s.regierungsbezirk AND l.kreis=s.kreis AND l.gemeinde=s.gemeinde AND l.lage=s.lage 
WHERE f.gml_id = $1 AND f.endet IS NULL AND l.endet IS NULL AND s.endet IS NULL;";

$v = array($gmlid);
$res = pg_prepare("", $sql);
$res = pg_execute("", $v);
if (!$res) {
	echo "\n<p class='err'>Fehler bei Lagebezeichnung ohne Hausnummer</p>";
	//if ($debug > 1) {echo "<p class='dbg'>Fehler:".pg_result_error($res)."</p>";}
	if ($debug > 2) {echo "\n<p class='dbg'>SQL=<br>".htmlentities($sql, ENT_QUOTES, "UTF-8")."<br>$1 = gml_id = '".$gmlid."'</p>";}
}
$j=0;
while($row = pg_fetch_assoc($res)) {
	$skey=$row["lage"]; // Strassenschl.
	$lgml=$row["gml_id"]; // key der Lage
	$gewann = htmlentities($row["unverschluesselt"], ENT_QUOTES, "UTF-8");
	if ($gewann != "") {
		echo "\n<tr>"
			."\n\t<td class='ll' title='unverschl&uuml;sselte Lagebezeichnung'><img src='ico/Lage_Gewanne.png' width='16' height='16' alt=''> Gewanne:</td>" // 1
			."\n\t<td></td>" // 2
			."\n\t<td class='lr' colspan='3'>".$gewann."</td>" // 3-5
			."\n\t<td>\n\t\t<p class='nwlink noprint'>" // 6
				."\n\t\t\t<a title='Flurst&uuml;cke mit der Gewanne ".$gewann."' href='alkislage.php?gkz=".$gkz."&amp;ltyp=o&amp;gmlid=".$lgml;
				if ($showkey) {echo "&amp;showkey=j";}				
				echo "'>\n\t\t\tLage <img src='ico/Lage_Gewanne.png' width='16' height='16' alt=''></a>"
			."\n\t\t</p>\n\t</td>" // 6
		."\n</tr>";
	} elseif ($skey > 0) {
		$sname=htmlentities($row["bezeichnung"], ENT_QUOTES, "UTF-8"); // Str.-Name
		if (substr($sname, strlen($sname) -3, 3) == 'weg') { // Versuch fuer korrekten Satzbau
			$slink=" am ".$sname;
		} else {
			$slink=" an der ".$sname;
		}
		echo "\n<tr>"
			."\n\t<td class='ll'><img src='ico/Lage_an_Strasse.png' width='16' height='16' alt=''> Stra&szlig;e:</td>" // 1
			."\n\t<td></td>" // 2
			."\n\t<td class='lr' colspan='3'>"; // 3-5
				if ($showkey) {echo "<span class='key'>(".$skey.")</span>&nbsp;";}
				echo $sname."</td>";
			echo "\n\t<td>\n\t\t<p class='nwlink noprint'>" // 6
				."\n\t\t\t<a title='Flurstücke ".$slink."' href='alkislage.php?gkz=".$gkz."&amp;ltyp=o&amp;gmlid=".$lgml;
				if ($showkey) {echo "&amp;showkey=j";}				
				echo "'>\n\t\t\tLage <img src='ico/Lage_an_Strasse.png' width='16' height='16' alt=''>\n\t\t\t</a>"
			."\n\t\t</p>\n\t</td>" // 6
		."\n</tr>";
	}
	$j++;
}
pg_free_result($res);

/* Status "N u t z u n g":
Die Classic-Tabelle "nutzung" ist eine Zusammenfassung aller Tabellen mit Nutzungs-Flächen
Die Classic-Tabelle "nutzung_meta" zeigt die Kategorie und Gruppe des Nutzungs-Abschnitts an.

Aus der norGIS-Struktur wird ersatzweise VORLÄUFIG die Tabelle "nutz_21" verwendet,
die das alte ALB-Format der Nutzungs-Abschnitte von Flurstücken simuliert.
Hier finden sich bereits verschnittene Flächen, aber die gml_id fehlt.

Die Entschlüsselung der Nutzungsart in den verschiedenen ALKIS-Varianten ist darin unterentwickelt.
Diese ist eigentlich für jede der getrennten Tabellen der Gruppe Nutzungsart individuell.
Die Classic-Lösung mit 2 Zusatzfeldern war schon sehr pauschalisiert, aber 
durch die Rück-Konvertierung in ALB-Strukturen in der norGIS-Version ist das zu stark vereinfacht.
z.B. wird "Wohnbaufläche" mit der Zusatzeigenschaft "Art der Bebauung": 'Offen'
nun zur Nutzungsart "Offen".
Durch JOIN auf die "alkis_elemente" mit einem Teil des Schlüssels wird das zur "Wohnbaufläche, Offen".
Es sollte eine Tabellen-Struktur bereit gestellt werden, die auch aussagt, dass der Wert "Offen" zur
Zusatz-Eigenschaft "Art der Bebauung" gehört. Dazu muss das PostProcessing erweitert werden. */

$sql="SELECT e.definition, trim(both FROM n.nutzsl) AS nutzsl, trim(both FROM n.fl) AS fl, trim(both FROM s.nutzung) AS nutzung
 FROM nutz_21 n JOIN nutz_shl s ON n.nutzsl = s.nutzshl
 JOIN alkis_elemente e ON e.kennung = substring(n.nutzsl from 1 for 5)
WHERE n.flsnr = $1 ORDER BY cast(n.fl AS integer) DESC;";
// Flurstueckskennzeichen mit Trennzeichen im ALB-Format wie 'llgggg-fff-zzzzz/nnn'
$fskennzalb=$defland.$gmkgnr."-".str_pad($flurnummer,3,"0",STR_PAD_LEFT)."-".str_pad($zaehler,5,"0",STR_PAD_LEFT)."/".str_pad($nenner,3,"0",STR_PAD_LEFT);
$v = array($fskennzalb);
$res = pg_prepare("", $sql);
$res = pg_execute("", $v);
if (!$res) {
	echo "\n<p class='err'>Fehler bei Suche tats. Nutzung</p>";
	if ($debug > 2) {echo "\n<p class='dbg'>SQL=<br>".htmlentities($sql, ENT_QUOTES, "UTF-8")."<br>$1 = FS-Kennz = '".$fskennzalb."'</p>";}
}
$j=0;
while($row = pg_fetch_assoc($res)) {
	$flae=$row["fl"]; // Buchfläche
	$nutzsl=$row["nutzsl"]; // Schlüssel
	$nutzung=$row["nutzung"]; // Bezeichnung aus ALB-Tabelle, "fein"
	$defi=$row["definition"]; // Langer Text mit Beschreibung
	$title=htmlentities($defi, ENT_QUOTES, "UTF-8"); // .. für Anzeige aufbereitet
	echo "\n<tr>\n\t";
		if ($j == 0) { // 1
			echo "<td class='ll' title='Abschnitt der tats&auml;chlichen Nutzung'><img src='ico/Abschnitt.png' width='16' height='16' alt=''> Nutzung:</td>";
		} else {
			echo "<td>&nbsp;</td>";
		}
		$absflaebuch = number_format($flae,0,",",".") . " m&#178;"; // Formatierte Abschnitts-Buch-Fläche
		echo "\n\t<td></td>"; // 2
		echo "\n\t<td class='fla' title='Buchfl&auml;che des Abschnitts'>".$absflaebuch."</td>"; // 3 - gleiche Spalte wie Fl. in Bodenschätzg.
		echo "\n\t<td></td>"; // 4
		echo "\n\t<td class='lr' title='".$title."'>"; // 5 - gleiche Sp. wie Zustandsstufe usw.
			if ($showkey) {echo "<span class='key'>(".$nutzsl.")</span> ";}
			echo $nutzung
		."</td>"
		."\n\t<td>"; // 6
/*		// Derzeit ist keine Gruppe zugeordnet
			switch ($grupp) { // Icon nach 4 Objektartengruppen
				case "Siedlung":   $ico = "Abschnitt.png"; break;
				case "Verkehr":	   $ico = "Strassen_Klassifikation.png"; break;
				case "Vegetation": $ico = "Wald.png"; break;
				case "Gewässer":   $ico = "Wasser.png";	break;
				default:	$ico = "Abschnitt.png";	break;
			}
			// Icon ist auch im Druck sichtbar, class='noprint' ?		
			echo "<p class='nwlink'><img title='".$title."' src='ico/".$ico."' width='16' height='16' alt='NUA'></p>"; */
		echo "</td>" // 6
	."\n</tr>";
	$j++;
}
pg_free_result($res);

echo "\n<tr>" // Flächen-Summenzeile
	."\n\t<td class='re' title='amtliche Fl&auml;che (Buchfl&auml;che)'>Fl&auml;che:</td>" // 1
	."\n\t<td>&nbsp;</td>" // 2
	."\n\t<td class='fla sum'>" // 3 Flaeche
		."<span title='geometrisch berechnete Fl&auml;che = ".$fsgeomflaed."' class='flae'>".$fsbuchflaed."</span></td>"
	."\n\t<td>&nbsp;</td>" // 4
	."\n\t<td>&nbsp;</td>" // 5
	."\n\t<td>" // 6 Link auf Gebäude-Auswertung
		."\n\t\t<p class='nwlink noprint'>" // Gebaeude-Verschneidung
		."\n\t\t\t<a href='alkisgebaeudenw.php?gkz=".$gkz."&amp;gmlid=".$gmlid;
		if ($showkey) {echo "&amp;showkey=j";}
		if ($cnt_adressen > 0) { // wenn Adresse vorgekommen ist
			echo "' title='Geb&auml;ude auf oder an dem Flurst&uuml;ck'>Geb&auml;ude ";
		} else { // Gebäude mit Adresse gibt es NICHT, das ist klar
			echo "' title='Suche Geb&auml;ude ohne Adresse auf dem Flurst&uuml;ck oder angrenzende Geb&auml;ude'>Suche ";
		}
		echo "<img src='ico/Haus.png' width='16' height='16' alt=''></a>"
		."\n\t\t</p>"
	."\n\t</td>" // 6
	."\n</tr>";

// B o d e n s c h ä t z u n g
// ---------------------------
// Tabelle "klas_3x" (norbit-ALB): Dort fehlen Bodenart und Zustandsstufe, es ist aber bereits auf Buchfläche umgerechnet.

// Bodenschätzungs-Abschnitte mit Flurstücken verschneiden, Spalten entschlüsseln
$sql="SELECT b.kulturart AS kulturartk, kulturart.beschreibung AS kulturartv,
 b.bodenart AS bodenartk, bodenart.beschreibung AS bodenartv, zustbod.beschreibung AS zustbodv,
 b.entstehungsartoderklimastufewasserverhaeltnisse AS entsteh, b.sonstigeangaben,
 b.bodenzahlodergruenlandgrundzahl as bodenzahl, b.ackerzahlodergruenlandzahl AS ackerzahl,
 b.jahreszahl, st_area(st_intersection(b.wkb_geometry, f.wkb_geometry)) AS schnittflae 
FROM ax_flurstueck f
JOIN ax_bodenschaetzung b ON st_intersects(b.wkb_geometry, f.wkb_geometry) AND st_area(st_intersection(b.wkb_geometry, f.wkb_geometry)) > 0.05
LEFT JOIN ax_bodenart_bodenschaetzung bodenart ON b.bodenart = bodenart.wert
LEFT JOIN ax_kulturart_bodenschaetzung kulturart ON b.kulturart = kulturart.wert
LEFT JOIN ax_zustandsstufeoderbodenstufe_bodenschaetzung zustbod ON b.zustandsstufeoderbodenstufe = zustbod.wert
WHERE f.gml_id = $1 AND f.endet IS NULL AND b.endet IS NULL ORDER BY schnittflae DESC";

$v = array($gmlid);
$res = pg_prepare("", $sql);
$res = pg_execute("", $v);
if (!$res) {echo "\n<p class='err'>Fehler bei DB-Abfrage zur Klassifizierung Boden</p>\n";}
$gesertragsmz = 0; // Gesamt-ErtragsMesszahl
$klasflae = 0; // Summe klassifizierte Fläche
$j=0;
if(!empty($res) && pg_num_rows($res) > 0) {
	while ($row = pg_fetch_assoc($res)) {
		$kulturartk=$row['kulturartk']; // Key	-
		$kulturartv=$row['kulturartv']; //		- Value
		// 1000="Ackerland (A)", 2000="Acker-Grünland (AGr)", 3000="Grünland (Gr)", 4000="Grünland-Acker (GrA)" 		
		if (substr($kulturartv, 0, 3) == 'Ack') { // A
			$kbez1="Bodenzahl";
			$kbez2="Ackerzahl";
		} else { // Gr
			$kbez1="Gr&uuml;nlandgrundzahl";
			$kbez2="Gr&uuml;nlandzahl";
		}
		$absflae = $row['schnittflae'];
		$absbuchflae = $absflae * $the_Xfactor;
		$klasflae+=$absbuchflae;
		$ertragszahl = intval($absbuchflae * $row['ackerzahl'] / 100);
		$gesertragsmz+=$ertragszahl;
	//	$absflaedis = number_format($absflae,0,",",".")." m&#178;";  // als Tool-Tip ?
		$absbuchflaedis = number_format($absbuchflae,0,",",".")." m&#178;";
		$boedenzahl=ltrim($row['bodenzahl'], '0');
		$ackerzahl=ltrim($row['ackerzahl'], '0');
		$jahr=$row['jahreszahl'];

		// 2x Array mit Schlüsseln. PostNAS füllt es nicht, wenn als "integer[]" definiert.
		$entsteh=$row['entsteh'];
		$sonst=$row['sonstigeangaben'];
		if ($j == 0) { // 1
			echo "\n<tr>\n\t<td class='ll' title='Abschnitt Bodensch&auml;tzung'><img src='ico/Landwirt.png' width='16' height='16' alt=''> Bodensch&auml;tzung:</td>";
		} else {
			echo "\n<tr>\n\t<td>&nbsp;</td>";
		}
		echo "\n\t<td class='fla' title='Ertragsmesszahl: Produkt von ".$kbez2."/100 und Fl&auml;che.'>EMZ ".$ertragszahl."</td>"; // 2
		echo "\n\t<td class='re' title='Fl&auml;che des Sch&auml;tzungsabschnitts'>".$absbuchflaedis."</td>"; // 3
		echo "\n\t<td class='lr'><span title='".$kbez1."'>".$boedenzahl."</span>/<span title='".$kbez2."'>".$ackerzahl."</span></td>"; // 4
		echo "\n\t<td class='lr'>"; // 5

			if ($showkey) {echo "\n\t\t<span class='key'>(".$kulturartk.")</span> ";}
			echo "\n\t\t<span title='Kulturart'>".$kulturartv."</span> ";

			if ($showkey) {echo "\n\t\t<span class='key'>(".$row['bodenartk'].")</span> ";}
			echo "\n\t\t<span title='Bodenart'>".$row['bodenartv']."</span> ";

			echo "\n\t\t<span title='Zustandsstufe'>".$row['zustbodv']."</span> ";

			// ARRAYs auflösen ohne den Schätzungs-Abschnitt mehrfach aufzulisten
			if ($entsteh <> '') {
				$ent="'".str_replace(",", "','", trim($entsteh, "{}"))."'"; // als Liste für SQL "WHERE IN ()"
				echo "\n\t\t <span title='Enststehungsart oder Klimastufe, Wasserverh&auml;ltnisse'>";
					if ($showkey) {echo "\n\t\t <span class='key'>(".$ent.")</span> ";}
					werteliste ('ax_bodenschaetzung', 'entstehungsartoderklimastufewasserverhaeltnisse', $ent);
				echo "</span>";
			}
			if ($sonst <> '') {
				$son="'".str_replace(",", "','", trim($sonst, "{}"))."'";
				echo "\n\t\t <span title='Sonstige Angaben'>";
					if ($showkey) {echo "\n\t\t <span class='key'>(".$son.")</span> ";}
					werteliste ('ax_bodenschaetzung', 'sonstigeangaben', $son);
				echo "</span>";
			}

			if ($jahr <> '') {
				echo "\n\t\t<span title='Jahreszahl'>".$jahr."</span>";
			}
		echo "\n\t</td>"; // 5
		echo "\n\t<td>&nbsp;</td>\n</tr>"; // 6
		$j++;
	}
	// Summenzeile
	$klasflaedis = number_format($klasflae,0,",",".")." m&#178;";
	echo "\n<tr>\n\t<td class='re'>Ertragsmesszahl:</td>" // 1
	."\n\t<td class='fla sum' title='Summe der Ertragsmesszahlen f&uuml;r dies Flurst&uuml;ck'>".$gesertragsmz."</td>" // 2
	."\n\t<td class='re'>".$klasflaedis."</td>" // 3
	."\n\t<td colspan='3'>&nbsp;</td>\n</tr>"; // 4-6
}

// H i n w e i s  auf Bodenneuordnung oder eine strittige Grenze
$sql_boden ="SELECT b.artderfestlegung AS wert, a.beschreibung AS art_verf, b.gml_id AS verf_gml, b.bezeichnung AS verf_bez, 
b.name AS verf_name, d.bezeichnung AS stelle_bez, d.stelle AS stelle_key 
FROM ax_bauraumoderbodenordnungsrecht b 
LEFT JOIN ax_artderfestlegung_bauraumoderbodenordnungsrecht a ON b.artderfestlegung = a.wert
LEFT JOIN ax_dienststelle d ON b.stelle=d.stelle 
WHERE b.endet IS NULL AND d.endet IS NULL  
AND (ST_Within((SELECT wkb_geometry FROM ax_flurstueck WHERE gml_id = $1 AND endet IS NULL ), wkb_geometry)
 OR ST_Overlaps((SELECT wkb_geometry FROM ax_flurstueck WHERE gml_id = $1 AND endet IS NULL), wkb_geometry));";

pg_prepare($con, "bodeneuordnung", $sql_boden);
$res_bodeneuordnung = pg_execute($con, "bodeneuordnung", array($gmlid));
if (!$res_bodeneuordnung) {
	echo "\n<p class='err'>Fehler bei Bau-, Raum- oder Bodenordnungsrecht</p>";
	if ($debug > 2) {echo "\n<p class='dbg'>SQL=<br>".$sql_boden."<br>$1 = gml_id = '".$gmlid."'</p>";}
}
$sql_str="SELECT gml_id FROM ax_besondereflurstuecksgrenze WHERE endet IS NULL AND 1000 = ANY(artderflurstuecksgrenze) 
AND ST_touches((SELECT wkb_geometry FROM ax_flurstueck WHERE gml_id = $1 AND endet IS NULL),wkb_geometry);";

pg_prepare($con, "strittigeGrenze", $sql_str);
$res_strittigeGrenze = pg_execute($con, "strittigeGrenze", array($gmlid));
if (!$res_strittigeGrenze) {
	echo "\n<p class='err'>Fehler bei strittige Grenze</p>";
	if ($debug > 2) {echo "\n<p class='dbg'>SQL=<br>".$sql_str."<br>$1 = gml_id = '".$gmlid."'</p>";}
}
if (pg_num_rows($res_bodeneuordnung) > 0 OR pg_num_rows($res_strittigeGrenze) > 0) {
	echo "\n<tr>"
	."\n\t<td title='Hinweise zum Flurst&uuml;ck'><h6><img src='ico/Hinweis.png' width='16' height='16' alt=''> " // 1
	."Hinweise:</h6></td>\n\t<td colspan='5'>&nbsp;</td>\n</tr>";// 2-6
	if (pg_num_rows($res_bodeneuordnung) > 0) {
		while ($row = pg_fetch_assoc($res_bodeneuordnung)) { // 3 Zeilen je Verfahren
			echo "\n<tr title='Bau-, Raum- oder Bodenordnungsrecht'>" // Zeile 1 - kommt immer, darum hier den Link
				."\n\t<td>Bodenrecht</td>" // 1
				."\n\t<td class='re'>Festlegung: </td>" // 2 "Art der Festlegung" zu lang
				."\n\t<td colspan='3'>"; // 3-5
					if ($showkey) {echo "<span class='key'>(".$row['wert'].")</span> ";}
					echo $row['art_verf']
				."</td>";
				echo "\n\t<td>" // 6 LINK:
					."\n\t\t<p class='nwlink noprint'>"
					."\n\t\t\t<a href='alkisbaurecht.php?gkz=".$gkz."&amp;gmlid=".$row['verf_gml'];
					if ($showkey) {echo "&amp;showkey=j";}
					echo "' title='Bau-, Raum- oder Bodenordnungsrecht'>Recht <img src='ico/Gericht.png' width='16' height='16' alt=''></a>"
					."\n\t\t</p>"		
				."\n\t</td>"
			."\n</tr>";
			$dstell=$row['stelle_key']; // Zeile 2
			if ($dstell != "") { // Kann auch leer sein
				echo "\n<tr title='Flurbereinigungsbeh&ouml;rde'>"
					."\n\t<td>&nbsp;</td>" // 1
					."\n\t<td class='re'>Dienststelle: </td>" // 2
					."\n\t<td colspan='3'>"; // 3-5
						if ($showkey) {echo "<span class='key'>(".$dstell.")</span> ";}
						echo $row['stelle_bez']
					."</td>"
					."\n\t<td>&nbsp;</td>" // 6
				."\n</tr>";
			}
			$vbez=$row['verf_bez']; // Zeile 3, ist nicht immer gefüllt
			$vnam=$row['verf_name']; // noch seltener
			if ($vbez != "") {
				echo "\n<tr title='Verfahrensbezeichnung'>"
					."\n\t<td>&nbsp;</td>"
					."\n\t<td class='re'>Verfahren: </td>"
					."\n\t<td colspan='3'>";
						if ($vnam == "") {
							echo $vbez; // nur die Nummer
						} else {	// Name oder beides
							if ($showkey) {echo "<span class='key'>(".$vbez.")</span> ";}
							echo $vnam;
						}
		 			echo "</td>"
					."\n\t<td>&nbsp;</td>"
				."\n</tr>";
			}
		}
	}
	if (pg_num_rows($res_strittigeGrenze) > 0) { // 1 Zeile
		echo "\n<tr>\n<td>Strittige Grenze:</td>"
		."<td colspan=4>Mindestens eine Flurst&uuml;cksgrenze ist als <b>strittig</b> zu bezeichnen. Sie kann nicht festgestellt werden, weil die Beteiligten sich nicht &uuml;ber den Verlauf einigen. Nach sachverst&auml;ndigem Ermessen der Katasterbeh&ouml;rde ist anzunehmen, dass das Liegenschaftskataster nicht die rechtm&auml;&szlig;ige Grenze nachweist.</td>"
		."\n<td>&nbsp;</td>\n</tr>";
	}
}
echo "\n</table>";

// B U C H U N G S S T E L L E N  zum FS
$bartgrp="";	// Buchungsart
$barttypgrp="";	// Buchungsart Typ
if ($gml_buchungsstelle == '') {echo "\n<p class='err'>Keine Buchungstelle zum Flurst&uuml;ck gefunden.</p>";}
echo "\n<table class='outer'>"; // ALLE Buchungen und Eigentümer in 4 Spalten EINER Tabelle ausgeben
	$stufe=1; // Schleifenzähler Tiefe
	$gezeigt=buchung_anzg($gml_buchungsstelle, $eig, false, $gmlid, 1); // die ("dienende") Buchung anzeigen, wenn nicht fiktiv. Liefert true/false

	$anzber=ber_bs_zaehl($gml_buchungsstelle); // Anzahl berechtigte Buchungen (nächste Stufe) zu dieser Buchung ermitteln
	$verf_next = array($gml_buchungsstelle); // Start Recursion mit einem Element
	//if ($debug > 2) {echo "<p class='dbg'>Nach Stufe ".$stufe.", Anzahl: ". $anzber ."</p>";}

	while ($anzber > 0 ) { // Stufe - recursiv in die Tiefe, solange es was zu verfolgen gibt
		$verf_akt=$verf_next; // die nächste Stufe als aktuell übernehmen ..
		$verf_next=array(); // .. und zum Auffüllen leeren
 		$stufe++;
		$i=0; // Schleifenzähler Elemente
		foreach($verf_akt as $gml_ber_bs) {
			$i++;
			if (ber_bs_zaehl($gml_ber_bs) > 0) {
				$verf_neu=ber_bs_anzg($gml_ber_bs, $eig, false, $gmlid, ""); // Anzeige ber. Buchungst., ggf. mit Eigentümer.
				$anz_neu=count($verf_neu); // Das Ergebnis zählen
			//	if ($debug > 2) {echo "<p class='dbg'>Weiter zu verfolgen: Stufe ".$stufe.", Element ".$i.", Anzahl: ".$anz_neu."</p>";}
				if ($anz_neu > 0) { // wenn neue geliefert
					$verf_next=array_merge($verf_next, $verf_neu); // die neuen an die Sammlung heften
				}
			}
		} // Ende Buchungs-Array in der Stufe
		$anzber=count($verf_next); // Sammlung auf Stufe zählen, Steuert die Schleife.
		//if ($debug > 2) {echo "<p class='dbg'>Nach Stufe ".$stufe.", Anzahl: ". $anzber ."</p>";}
	} // Ende Stufe
echo "\n</table>\n\n";

pg_close($con);
echo <<<END
<div class='buttonbereich noprint'>
<hr>
	<a title="zur&uuml;ck" href='javascript:history.back()'><img src="ico/zurueck.png" width="16" height="16" alt="zur&uuml;ck"></a>&nbsp;
	<a title="Drucken" href='javascript:window.print()'><img src="ico/print.png" width="16" height="16" alt="Drucken"></a>&nbsp;
END;
echo "\n\t<a title='Export als CSV' href='javascript:ALKISexport(\"" . $gmlid . "\")'><img src='ico/download_fs.png' width='32' height='16' alt='Export'></a>&nbsp;\n</div>";

footer($gmlid, $_SERVER['PHP_SELF']."?", "&amp;eig=".$eig);
?>
</body>
</html>